Subject: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-policy

From: "John G. Scudder" <[email-masked]>
Date: Tue, 3 Oct 2017 17:17:03 -0400

Hi WG,

Over a month ago we had a request for early allocation of the code points in draft-ietf-idr-segment-routing-te-policy. I think that means the TBD code points listed in section 8.3, the Preference, Binding SID, and Segment List sub-TLVs, since all the rest have been properly allocated by IANA already. The draft appears to fulfill the requirements for early allocation, with one possible exception.

RFC 7120 says 

   c.  The specifications of these code points must be stable; i.e., if
       there is a change, implementations based on the earlier and later
       specifications must be seamlessly interoperable.

On the face of it the current version of the spec fulfills this requirement. I'm slightly concerned that up through draft-previdi-idr-segment-routing-te-policy-02, there were specific values given for 

   o  new sub-TLVs in the registry "BGP Tunnel Encapsulation Attribute
      sub-TLVs":

         Suggested         Description            Reference
            Value
          -----------------------------------------------------
              6           Preference sub-TLV       This document
              7           Binding SID sub-TLV      This document
              8           Segment List sub-TLV     This document

These values conflict with values allocated for other uses in the IANA registry. This was corrected quite some time ago, in -03 published December of 2016, which lists the values as "TBD" just as the current version does, so maybe there's no problem at all. 

I presume that if we proceed forward with early allocation, any pre-standard implementations will be updated to use whatever values IANA actually allocates -- which are sure not to be 6, 7 or 8 since those are already in use. If that's so, then fine. If not, then we may need to have a discussion about whether we really meet the "stability" requirement.

This begins a one-week period for discussion of the early allocation, which time period may be extended if conversation warrants it. For completeness, here's my evaluation of the full list of RFC 7120 criteria:

   a.  The code points must be from a space designated as "RFC
       Required", "IETF Review", or "Standards Action".  Additionally,
       requests for early assignment of code points from a
       "Specification Required" registry are allowed if the
       specification will be published as an RFC.

Yes.

   b.  The format, semantics, processing, and other rules related to
       handling the protocol entities defined by the code points
       (henceforth called "specifications") must be adequately described
       in an Internet-Draft.

Yes.

   c.  The specifications of these code points must be stable; i.e., if
       there is a change, implementations based on the earlier and later
       specifications must be seamlessly interoperable.

Tentatively yes but see above.

   d.  The Working Group chairs and Area Directors (ADs) judge that
       there is sufficient interest in the community for early (pre-RFC)
       implementation and deployment, or that failure to make an early
       allocation might lead to contention for the code point in the
       field.

Yes.

Thanks,

--John

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Fri, 6 Oct 2017 05:53:48 +0000

John -

Thanx for the detailed analysis.
Inline.

> -----Original Message-----
> From: Idr [mailto:[email-masked]] On Behalf Of John G. Scudder
> Sent: Tuesday, October 03, 2017 2:17 PM
> To: [email-masked]
> Cc: [email-masked]
> Subject: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-
> policy
> 
> Hi WG,
> 
> Over a month ago we had a request for early allocation of the code points in
> draft-ietf-idr-segment-routing-te-policy. I think that means the TBD code
> points listed in section 8.3, the Preference, Binding SID, and Segment List
> sub-TLVs, since all the rest have been properly allocated by IANA already.
> The draft appears to fulfill the requirements for early allocation, with one
> possible exception.
> 
> RFC 7120 says
> 
> On the face of it the current version of the spec fulfills this requirement. I'm
> slightly concerned that up through draft-previdi-idr-segment-routing-te-
> policy-02, there were specific values given for
> 
> These values conflict with values allocated for other uses in the IANA
> registry. This was corrected quite some time ago, in -03 published December
> of 2016, which lists the values as "TBD" just as the current version does, so
> maybe there's no problem at all.
> 
> I presume that if we proceed forward with early allocation, any pre-standard
> implementations will be updated to use whatever values IANA actually
> allocates -- which are sure not to be 6, 7 or 8 since those are already in use. If
> that's so, then fine. If not, then we may need to have a discussion about
> whether we really meet the "stability" requirement.
> 
[Les:] It is quite useful I think to point out this fact - but I fail to see how it is relevant to the early allocation decision.  Given that we know that these early codepoints are not available, I do not see that delaying early allocation helps in any way. If there are implementations that used these unassigned codepoints, the sooner we assign values the sooner these implementations can be updated to use values which will be interoperable - so if anything the facts argue that we should accelerate early allocation - not delay it.

???

   Les

> This begins a one-week period for discussion of the early allocation, which
> time period may be extended if conversation warrants it. For completeness,
> here's my evaluation of the full list of RFC 7120 criteria:
> 
> _______________________________________________
> Idr mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/idr

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Fri, 6 Oct 2017 11:28:44 +0000

Hi John, Les,

On 10/6/17, 1:53 AM, "Idr on behalf of Les Ginsberg (ginsberg)"
<[email-masked] on behalf of [email-masked]> wrote:

>[Les:] It is quite useful I think to point out this fact - but I fail to
>see how it is relevant to the early allocation decision.  Given that we
>know that these early codepoints are not available, I do not see that
>delaying early allocation helps in any way. If there are implementations
>that used these unassigned codepoints, the sooner we assign values the
>sooner these implementations can be updated to use values which will be
>interoperable - so if anything the facts argue that we should accelerate
>early allocation - not delay it.

I agree totally, we’ll achieve nothing by delaying this any longer.

Thanks,
Acee

---

From: "John G. Scudder" <[email-masked]>
Date: Fri, 6 Oct 2017 08:50:17 -0400

> [Les:] It is quite useful I think to point out this fact - but I fail to see how it is relevant to the early allocation decision.  Given that we know that these early codepoints are not available,…

That is a fine position to take and consistent with what I tried to express (whether it came through clearly or not).

Thanks,

--John

---

From: Jeff Tantsura <[email-masked]>
Date: Fri, 6 Oct 2017 09:32:00 -0700

+1
Having code points allocated early would save early implementations from changing later on, de-allocation for drafts that didn’t make it should be quite straightforward process.

Regards,
Jeff

> On Oct 6, 2017, at 04:28, Acee Lindem (acee) <[email-masked]> wrote:
> 
> Hi John, Les,
>

---

From: "Gaurav Dawra (gdawra)" <[email-masked]>
Date: Fri, 6 Oct 2017 20:17:28 +0000

John,

+1

We would like to request for allocation for following Sub-TLV to be. Pls let us know when the allocation is done.

Preference sub-TLV

6

Binding SID sub-TLV

7

Segment List sub-TLV

128

Cheers,

Gaurav

From: Idr <[email-masked]> on behalf of "John G. Scudder" <[email-masked]>
Date: Friday, October 6, 2017 at 5:50 AM
To: "Les Ginsberg (ginsberg)" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-policy

On Oct 6, 2017, at 1:53 AM, Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>> wrote:
[Les:] It is quite useful I think to point out this fact - but I fail to see how it is relevant to the early allocation decision.  Given that we know that these early codepoints are not available, I do not see that delaying early allocation helps in any way. If there are implementations that used these unassigned codepoints, the sooner we assign values the sooner these implementations can be updated to use values which will be interoperable - so if anything the facts argue that we should accelerate early allocation - not delay it.

Thanks,

--John

---

From: "John G. Scudder" <[email-masked]>
Date: Fri, 6 Oct 2017 16:31:02 -0400

Hi Gaurav,

This thread is exactly to discuss the proposed early allocation for those sub-TLVs. However I'm a little confused (or perhaps concerned) by your note, since you list explicit values that aren't available. As you can see if you consult the IANA registry (https://www.iana.org/assignments/bgp-parameters/bgp-parameters.xhtml#tunnel-sub-tlvs) both 6 and 7 have already been allocated. 128 is currently unallocated and I see no reason that preference couldn't be satisfied, but I don't think the requests for 6 and 7 can be.

I would anticipate IANA would allocate the first two unused values for Preference and Binding SID.

As for when it will be done, the discussion period will close this coming Tuesday, October 10. Assuming no blocking objections are raised, I'll forward the request to the AD and IANA. They've usually been able to process such requests within a few days, so it's possible the values will be allocated before end of next week. Of course I'll keep the list posted about progress.

--John

> On Oct 6, 2017, at 4:17 PM, Gaurav Dawra (gdawra) <[email-masked]> wrote:
> 
> John,
>  
> +1
>  
> On Oct 6, 2017, at 1:53 AM, Les Ginsberg (ginsberg) <[email-masked] <mailto:[email-masked]>> wrote:

---

From: "Gaurav Dawra (gdawra)" <[email-masked]>
Date: Sat, 7 Oct 2017 00:52:14 +0000

Hey John,

Understood. Thanks for clarification. Just wanted to indicate we support allocating the code points (whatever value they may be) as soon as possible.

Thanks again for considering our request.

Cheers,

Gaurav

From: "John G. Scudder" <[email-masked]>
Date: Friday, October 6, 2017 at 1:31 PM
To: Gaurav Dawra <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>, "Les Ginsberg (ginsberg)" <[email-masked]>, "Jose Liste (jliste)" <[email-masked]>, "Arjun Sreekantiah (asreekan)" <[email-masked]>, "Dhanendra Jain (dhjain)" <[email-masked]>
Subject: Re: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-policy

Hi Gaurav,

--John

On Oct 6, 2017, at 4:17 PM, Gaurav Dawra (gdawra) <[email-masked]<mailto:[email-masked]>> wrote:

John,

+1

Preference sub-TLV

6

Binding SID sub-TLV

7

Segment List sub-TLV

128

Cheers,

Gaurav

From: Idr <[email-masked]<mailto:[email-masked]>> on behalf of "John G. Scudder" <[email-masked]<mailto:[email-masked]>>
Date: Friday, October 6, 2017 at 5:50 AM
To: "Les Ginsberg (ginsberg)" <[email-masked]<mailto:[email-masked]>>
Cc: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-policy

Thanks,

--John

---

From: "Adrian Farrel" <[email-masked]>
Date: Tue, 10 Oct 2017 17:43:28 +0100

In full agreement.

Let's get the "early" allocation done using some nice clean codepoints from the
good folk at IANA.

John, what's the next step?

A

> From: Idr [mailto:[email-masked]] On Behalf Of Jeff Tantsura
> Sent: 06 October 2017 17:32
> To: Acee Lindem (acee)
> Cc: [email-masked]; [email-masked]
> Subject: Re: [Idr] Early allocation request for
draft-ietf-idr-segment-routing-te-
> policy
> 
> +1
> Having code points allocated early would save early implementations from
> changing later on, de-allocation for drafts that didn't make it should be
quite
> straightforward process.
> > I agree totally, we'll achieve nothing by delaying this any longer.
> >
> > Thanks,
> > Acee
> >
> >
> >
> >>
> >> ???
> >>
> >>  Les
> >>
> >>

---

From: "John G. Scudder" <[email-masked]>
Date: Thu, 12 Oct 2017 13:13:17 -0400

We have all needed approvals and have forwarded the request to IANA. I'l update the list when the allocation has been completed.

--John

---

From: "John G. Scudder" <[email-masked]>
Date: Thu, 12 Oct 2017 14:04:54 -0400

> We have all needed approvals and have forwarded the request to IANA. I'l update the list when the allocation has been completed.

And, done.

12	Preference sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)	[draft-ietf-idr-segment-routing-te-policy]

13	Binding SID sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)	[draft-ietf-idr-segment-routing-te-policy]

128	Segment List sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)	[draft-ietf-idr-segment-routing-te-policy]

https://www.iana.org/assignments/bgp-parameters/bgp-parameters.xhtml#tunnel-sub-tlvs

Kudos to IANA for turning their part around in 47 minutes. By the way, this kind of turnaround time is a big part of why I'm becoming so enthusiastic about FCFS as an allocation policy.

--John

---

From: "Gaurav Dawra (gdawra)" <[email-masked]>
Date: Thu, 12 Oct 2017 18:11:55 +0000

Thanks John.

Regards,

Gaurav

From: Idr <[email-masked]> on behalf of "John G. Scudder" <[email-masked]>
Date: Thursday, October 12, 2017 at 11:04 AM
To: "[email-masked]" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: Re: [Idr] Early allocation request for draft-ietf-idr-segment-routing-te-policy

On Oct 12, 2017, at 1:13 PM, John G. Scudder <[email-masked]<mailto:[email-masked]>> wrote:
We have all needed approvals and have forwarded the request to IANA. I'l update the list when the allocation has been completed.

And, done.

12 Preference sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)
[draft-ietf-idr-segment-routing-te-policy]

13 Binding SID sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)
[draft-ietf-idr-segment-routing-te-policy]

128 Segment List sub-TLV (TEMPORARY - registered 2017-10-12, expires 2018-10-12)
[draft-ietf-idr-segment-routing-te-policy]

--John